#include <stdio.h>
#include <stdlib.h>
int main(int argc, char *argv[]) {
	
	int n, q, i, br, j, z;
	long long int plazma[n*2], pitanja[q], pojela[1000];	
	
	scanf("%d%d",&n,&q);
	
	for(i=0;i<n*2;i++)
	{
		scanf("%lld",&plazma[i]);
	}
	
	for(i=0;i<q;i++)
	{
		scanf("%lld",&pitanja[i]);
	}
	
	for(i=0;i<q;i++)
	{
		pojela[i]=0;
	}
	
	for(i=0;i<q;i++)
	{
		br=0;
		z=0;
		for(j=0;j<=pitanja[i];j++)
		{
			if(plazma[z]==j)
			{
				br += plazma[z+1];
				z += 2;
			}
			
			if(br>0)
			{
				pojela[i]++;
				br--;
			}
		}
	}
	
	for(i=0;i<q;i++)
	{
		printf("%lld\n", pojela[i]);
	}
	
	return 0;
}